import org.junit.Test;

import static org.junit.Assert.*;

public class MySetTest {

    @Test
    public void testAdd(){
        Integer value = 3;
        Integer[] array = {1,2};
        MySet<Integer> arr = new MySet<>(array);

        Integer[] expected = {1,2,value};
        boolean actual = arr.add(value);

        assertTrue(actual);
    }
    @Test
    public void testAddContainsAlready(){

        Integer value = 3;
        Integer[] array = {1,2,value};

        MySet<Integer> arr = new MySet<>(array);

        //Integer[] expected = {1,2,3};
        boolean actual = arr.add(value);

        assertFalse(actual);
    }

    @Test
    public void testAddAll(){
        Long[] array = {};
        Long[] array2merge = {3L,4L};

        MySet<Long> arr = new MySet<>(array);

        boolean actual = arr.addAll(array2merge);

        assertFalse(actual);

    }

    @Test
    public void testAddAllContainsAlready(){
        Long[] array = {1L,2L,3L,4L};
        Long[] array2merge = {1L,2L,3L,4L};

        MySet<Long> arr = new MySet<>(array);

        boolean actual = arr.addAll(array2merge);

        assertFalse(actual);

    }


    @Test
    public void clearTest(){
        Integer[] array = {1,552,2456,63654};
        Integer[] expected = {};
        MySet<Integer> arr = new MySet<>(array);
        Integer[] actual = arr.clear();

        assertArrayEquals(expected,actual);

    }

    @Test
    public void containsTest(){
        String value = "a";
        String[] array = {"b", value, "e"};
        MySet<String> arr = new MySet<>(array);

        //String expected = "a";
        boolean actual = arr.contains(value);

        assertTrue(actual);

    }
    @Test
    public void doesnotContain(){
        int value = 3;
        Integer[] array = {1,2,5};
        MySet<Integer> arr = new MySet<>(array);

        boolean actual = arr.contains(value);
        assertFalse(actual);

    }

    @Test
    public void equal(){
        Integer value = 3;
        Integer[] array = {value,4,value,5,6};
        MySet<Integer> arr = new MySet<>(array);

        boolean actual = arr.equal(value);
        assertTrue(actual);

    }
    @Test
    public void notEqual(){

        Integer value = 3;
        Integer[] array = {2,4,6};
        MySet<Integer> arr = new MySet<>(array);

        boolean actual = arr.equal(value);
        assertFalse(actual);
    }

    @Test
    public void isEmptyTest(){
        Object[] array = {};
        MySet<Object> arr = new MySet<>(array);

        boolean actual = arr.isEmpty();

        assertTrue(actual);
    }
    @Test
    public void isNoEmptyTest(){
        Object[] array = {3,4,"a"};
        MySet<Object> arr = new MySet<>(array);

        boolean actual = arr.isEmpty();

        assertFalse(actual);
    }

    @Test
    public void hashCodaTest(){
        Integer[] array = {1,2,3};
        MySet<Integer> arr = new MySet<>(array);

        int expected =array.hashCode();
        int actual = arr.hashaCode();

        assertEquals(expected,actual);

    }
    @Test
    public void testSize(){
        Integer[] array = {1,2,3};
        MySet<Integer> arr = new MySet<>(array);

        int expected = 3;
        int actual = arr.size();

        assertEquals(expected,actual);
    }
    @Test
    public void testRemove(){
        String value = "aleena";
        int index = 0;
        String[] array = {"shiva", value};
        MySet<String> arr = new MySet<>(array);

        String[] expected = {"shiva"};
        String[] actual = arr.remove(index);

    }
}